Index: trunk/MagicSoft/Mars/mraw/MRawEvtData.cc
===================================================================
--- trunk/MagicSoft/Mars/mraw/MRawEvtData.cc	(revision 2461)
+++ trunk/MagicSoft/Mars/mraw/MRawEvtData.cc	(revision 2466)
@@ -58,4 +58,5 @@
 #include <TGraph.h>
 #include <TArrayC.h>
+#include <TVirtualPad.h>
 
 #include "MLog.h"
@@ -213,5 +214,4 @@
 //     <index>      The pixel with the given index is drawn
 //
-#include <TVirtualPad.h>
 void MRawEvtData::Draw(Option_t *opt)
 {
Index: trunk/MagicSoft/Mars/mraw/MRawSocketRead.cc
===================================================================
--- trunk/MagicSoft/Mars/mraw/MRawSocketRead.cc	(revision 2461)
+++ trunk/MagicSoft/Mars/mraw/MRawSocketRead.cc	(revision 2466)
@@ -16,7 +16,7 @@
 !
 !
-!   Author(s): Thomas Bretz  12/2000 <mailto:tbretz@uni-sw.gwdg.de>
-!
-!   Copyright: MAGIC Software Development, 2000-2001
+!   Author(s): Thomas Bretz, 10/2003 <mailto:tbretz@astro.uni-wuerzburg.de>
+!
+!   Copyright: MAGIC Software Development, 2000-2003
 !
 !
@@ -24,21 +24,21 @@
 
 //////////////////////////////////////////////////////////////////////////////
-//                                                                          //
-//  MRawSocketRead                                                            //
-//                                                                          //
-//  This tasks reads the raw binary file like specified in the TDAS???      //
-//  and writes the data in the corresponding containers which are           //
-//  either retrieved from the parameter list or created and added.          //
-//                                                                          //
-//  Input Containers:                                                       //
-//   -/-                                                                    //
-//                                                                          //
-//  Output Containers:                                                      //
-//   MRawRunHeader, MRawEvtHeader, MRawEvtData, MRawCrateArray, MRawEvtTime //
-//                                                                          //
+//
+//  MRawSocketRead
+//
+//  This tasks reads the raw binary file like specified in the TDAS???
+//  and writes the data in the corresponding containers which are
+//  either retrieved from the parameter list or created and added.
+//
+//  Input Containers:
+//   -/-
+//
+//  Output Containers:
+//   MRawRunHeader, MRawEvtHeader, MRawEvtData, MRawCrateArray, MRawEvtTime
+//
 //////////////////////////////////////////////////////////////////////////////
 #include "MRawSocketRead.h"
 
-#include <TMutex.h>
+#include <stdlib.h> // atoi
 
 #include "MReadSocket.h"
@@ -58,4 +58,6 @@
 #include "MRawCrateArray.h"
 
+//#include "../mmain/MStatusDisplay.h"
+
 ClassImp(MRawSocketRead);
 
@@ -73,5 +75,4 @@
 
     fIn = new MReadSocket(7000);
-    fMutex = new TMutex;
 }
 
@@ -82,5 +83,4 @@
 MRawSocketRead::~MRawSocketRead()
 {
-    delete fMutex;
     delete fIn;
 }
@@ -140,5 +140,13 @@
 }
 
-Int_t MRawSocketRead::Do()
+// --------------------------------------------------------------------------
+//
+// The Process reads one event from the binary file:
+//  - The event header is read
+//  - the run header is read
+//  - all crate information is read
+//  - the raw data information of one event is read
+//
+Int_t MRawSocketRead::Process()
 {
     /*
@@ -254,37 +262,23 @@
     }
 
+    //
+    // If no new event was recorded the DAQ resends an old event
+    //
     if (fEvtNumber==fRawEvtHeader->GetDAQEvtNumber())
         return kCONTINUE;
 
     fEvtNumber=fRawEvtHeader->GetDAQEvtNumber();
-
-    //*fLog << dbg << "Evt " << fRawEvtHeader->GetDAQEvtNumber() << endl;
-
+/*
+    if (fDisplay)
+        fDisplay->SetProgressBarPosition((Float_t)fEvtNumber/fRawRunHeader->GetNumEvents());
+ */
     return kTRUE;
 }
 
-// --------------------------------------------------------------------------
-//
-// The Process reads one event from the binary file:
-//  - The event header is read
-//  - the run header is read
-//  - all crate information is read
-//  - the raw data information of one event is read
-//
-Int_t MRawSocketRead::Process()
-{
-    Lock();
-    Int_t rc = Do();
-    UnLock();
-    return rc;
-}
-
-Int_t MRawSocketRead::Lock()
-{
-    return fMutex->Lock();
-}
-
-Int_t MRawSocketRead::UnLock()
-{
-    return fMutex->UnLock();
-}
+Int_t MRawSocketRead::PostProcess()
+{   /*
+    if (fDisplay)
+        fDisplay->SetProgressBarPosition(1);
+     */
+    return kTRUE;
+}
Index: trunk/MagicSoft/Mars/mraw/MRawSocketRead.h
===================================================================
--- trunk/MagicSoft/Mars/mraw/MRawSocketRead.h	(revision 2461)
+++ trunk/MagicSoft/Mars/mraw/MRawSocketRead.h	(revision 2466)
@@ -6,16 +6,15 @@
 #endif
 
-// gcc 3.2
-//class ifstream;
+#ifndef __IOSFWD__
 #include <iosfwd>
+#endif
 
 class MTime;
 class MParList;
+class MReadSocket;
+class MRawEvtData;
+class MRawEvtHeader;
 class MRawRunHeader;
-class MRawEvtHeader;
-class MRawEvtData;
 class MRawCrateArray;
-class MReadSocket;
-class TMutex;
 
 class MRawSocketRead : public MTask
@@ -28,6 +27,4 @@
     MTime          *fRawEvtTime;    // raw evt time information container to fill from file
 
-    TMutex *fMutex;
-
     MReadSocket    *fIn;            //! buffered input stream (file to read from)
     MParList       *fParList;       //!
@@ -36,8 +33,7 @@
     UInt_t          fEvtNumber;     //!
 
-    Int_t Do();
-
     Int_t PreProcess(MParList *pList);
     Int_t Process();
+    Int_t PostProcess();
 
 public:
@@ -45,7 +41,4 @@
     ~MRawSocketRead();
 
-    Int_t Lock();
-    Int_t UnLock();
-
     ClassDef(MRawSocketRead, 0)	//Task to read DAQ binary data from tcp/ip socket
 };