Index: trunk/MagicSoft/Mars/manalysis/MBlindPixelCalc.cc
===================================================================
--- trunk/MagicSoft/Mars/manalysis/MBlindPixelCalc.cc	(revision 2454)
+++ trunk/MagicSoft/Mars/manalysis/MBlindPixelCalc.cc	(revision 2470)
@@ -59,8 +59,10 @@
 //
 //  Input Containers:
-//   MCerPhotEvt[, MBlindPixels]
+//   MCerPhotEvt
+//   [MBlindPixels]
 //
 //  Output Containers:
-//   MCerPhotEvt, MBlindPixels
+//   MCerPhotEvt
+//   MBlindPixels
 //
 /////////////////////////////////////////////////////////////////////////////
@@ -112,11 +114,11 @@
 {
     if (TESTBIT(fFlags, kUseBlindPixels))
-        fPixels = (MBlindPixels*)pList->FindObject("MBlindPixels");
+        fPixels = (MBlindPixels*)pList->FindObject(AddSerialNumber("MBlindPixels"));
     else
-        fPixels = (MBlindPixels*)pList->FindCreateObj("MBlindPixels");
+        fPixels = (MBlindPixels*)pList->FindCreateObj(AddSerialNumber("MBlindPixels"));
     if (!fPixels)
 	return kFALSE; 
     
-    fEvt = (MCerPhotEvt*)pList->FindObject("MCerPhotEvt");
+    fEvt = (MCerPhotEvt*)pList->FindObject(AddSerialNumber("MCerPhotEvt"));
     if (!fEvt)
     {
@@ -124,5 +126,5 @@
         return kFALSE;
     }
-    fPed = (MPedestalCam*)pList->FindObject("MPedestalCam");
+    fPed = (MPedestalCam*)pList->FindObject(AddSerialNumber("MPedestalCam"));
     if (!fEvt)
     {
@@ -131,5 +133,5 @@
     }
 
-    fGeomCam = (MGeomCam*)pList->FindObject("MGeomCam");
+    fGeomCam = (MGeomCam*)pList->FindObject(AddSerialNumber("MGeomCam"));
     if (!fGeomCam)
         *fLog << warn << dbginf << "No camera geometry available... can't use interpolation." << endl;
Index: trunk/MagicSoft/Mars/manalysis/MCerPhotCalc.cc
===================================================================
--- trunk/MagicSoft/Mars/manalysis/MCerPhotCalc.cc	(revision 2454)
+++ trunk/MagicSoft/Mars/manalysis/MCerPhotCalc.cc	(revision 2470)
@@ -35,5 +35,7 @@
 //
 //  Input Containers:
-//   MRawRunHeader, MRawEvtData, MPedestalCam
+//   MRawEvtData
+//   MPedestalCam
+//   [MRawRunHeader]
 //
 //  Output Containers:
@@ -99,5 +101,5 @@
     }
 
-    fRawEvt = (MRawEvtData*)pList->FindObject("MRawEvtData");
+    fRawEvt = (MRawEvtData*)pList->FindObject(AddSerialNumber("MRawEvtData"));
     if (!fRawEvt)
     {
@@ -106,5 +108,5 @@
     }
 
-    fPedestals = (MPedestalCam*)pList->FindCreateObj("MPedestalCam");
+    fPedestals = (MPedestalCam*)pList->FindCreateObj(AddSerialNumber("MPedestalCam"));
     if (!fPedestals)
     {
@@ -113,5 +115,5 @@
     }
 
-    fCerPhotEvt = (MCerPhotEvt*)pList->FindCreateObj("MCerPhotEvt");
+    fCerPhotEvt = (MCerPhotEvt*)pList->FindCreateObj(AddSerialNumber("MCerPhotEvt"));
     if (!fCerPhotEvt)
         return kFALSE;
Index: trunk/MagicSoft/Mars/manalysis/MGeomApply.cc
===================================================================
--- trunk/MagicSoft/Mars/manalysis/MGeomApply.cc	(revision 2454)
+++ trunk/MagicSoft/Mars/manalysis/MGeomApply.cc	(revision 2470)
@@ -44,5 +44,6 @@
 //
 //  Output Containers:
-//   MPedestalCam, MBlindPixels
+//   [MPedestalCam]
+//   [MBlindPixels]
 //
 //////////////////////////////////////////////////////////////////////////////
@@ -79,9 +80,9 @@
 Int_t MGeomApply::PreProcess(MParList *pList)
 {
-    MGeomCam *cam = (MGeomCam*)pList->FindObject("MGeomCam");
+    MGeomCam *cam = (MGeomCam*)pList->FindObject(AddSerialNumber("MGeomCam"));
     if (cam)
         return kTRUE;
 
-    cam = (MGeomCam*)pList->FindCreateObj(fGeomName, "MGeomCam");
+    cam = (MGeomCam*)pList->FindCreateObj(AddSerialNumber(fGeomName), "MGeomCam");
 
     return cam ? kTRUE : kFALSE;
@@ -97,5 +98,5 @@
 Bool_t MGeomApply::ReInit(MParList *pList)
 {
-    MGeomCam *cam = (MGeomCam*)pList->FindObject("MGeomCam");
+    MGeomCam *cam = (MGeomCam*)pList->FindObject(AddSerialNumber("MGeomCam"));
     if (!cam)
     {
@@ -104,9 +105,9 @@
     }
 
-    MPedestalCam *ped = (MPedestalCam*)pList->FindObject("MPedestalCam");
+    MPedestalCam *ped = (MPedestalCam*)pList->FindObject(AddSerialNumber("MPedestalCam"));
     if (ped)
         ped->InitSize(cam->GetNumPixels());
 
-    MBlindPixels *bnd = (MBlindPixels*)pList->FindObject("MBlindPixels");
+    MBlindPixels *bnd = (MBlindPixels*)pList->FindObject(AddSerialNumber("MBlindPixels"));
     if (bnd)
         bnd->InitSize(cam->GetNumPixels());
Index: trunk/MagicSoft/Mars/manalysis/MMcPedestalCopy.cc
===================================================================
--- trunk/MagicSoft/Mars/manalysis/MMcPedestalCopy.cc	(revision 2454)
+++ trunk/MagicSoft/Mars/manalysis/MMcPedestalCopy.cc	(revision 2470)
@@ -33,4 +33,6 @@
 //  Input Containers:
 //   MMcFadcHeader
+//   [MMcRunHeader]
+//   [MRawRunHeader]
 //
 //  Output Containers:
@@ -104,5 +106,12 @@
     // to be done only if this is a MC file.
     //
-    MPedestalCam *pedcam = (MPedestalCam*)pList->FindCreateObj("MPedestalCam");
+    MMcFadcHeader *fadc = (MMcFadcHeader*)pList->FindObject(AddSerialNumber("MMcFadcHeader"));
+    if (!fadc)
+    {
+        *fLog << err << dbginf << "MMcFadcHeader not found... aborting." << endl;
+        return kFALSE;
+    }
+
+    MPedestalCam *pedcam = (MPedestalCam*)pList->FindCreateObj(AddSerialNumber("MPedestalCam"));
     if (!pedcam)
         return kFALSE;
@@ -111,11 +120,4 @@
     if (!mcrun)
         *fLog << warn << dbginf << "MMcRunHeader not found... assuming camera<0.7" << endl;
-
-    MMcFadcHeader *fadc = (MMcFadcHeader*)pList->FindObject("MMcFadcHeader");
-    if (!fadc)
-    {
-        *fLog << err << dbginf << "MMcFadcHeader not found... aborting." << endl;
-        return kFALSE;
-    }
 
     const int num = pedcam->GetSize();
Index: trunk/MagicSoft/Mars/manalysis/MMcPedestalNSBAdd.cc
===================================================================
--- trunk/MagicSoft/Mars/manalysis/MMcPedestalNSBAdd.cc	(revision 2454)
+++ trunk/MagicSoft/Mars/manalysis/MMcPedestalNSBAdd.cc	(revision 2470)
@@ -24,30 +24,30 @@
 
 /////////////////////////////////////////////////////////////////////////////
-//                                                                         //
-//  MMcPedestalNSBAdd                                                      //
-//  -----------------                                                      //
-//                                                                         //
-//  This Task adds the contribution of the diffuse NSB to the FADC         //
-//  pedestals. We assume that NSB introduces larger fluctuation but does   //
-//  not change the mean value.                                             //
-//  To be precise we add quadratically to the rms, which is already in     //
-//  MPedestalCam, the NSB contribution.                                    //
-//  The number of photons from the diffuse NSB follows a poisson           // 
-//  distribution with expected mean value X, then its standard deviation   //
-//  is sqrt(X).                                                            //
-//  X is the number of phe per ns so we have to convert in FADC counts per // 
-//  slice:                                                                 //
-//                                                                         //
-//  Y = sqrt(X * FADC_time / Number_of_slices * pixel_size)                //
-//      * Amp_single_phe_response                                          //
-//                                                                         //
-//  Input Containers:                                                      //
-//   MMcFadcHeader                                                         //
-//   MMcRunHeader                                                          //
-//   MRawRunHeader                                                         //
-//                                                                         //
-//  Output Containers:                                                     //
-//   MPedestalCam                                                          //
-//                                                                         //
+//
+//  MMcPedestalNSBAdd
+//  -----------------
+//
+//  This Task adds the contribution of the diffuse NSB to the FADC
+//  pedestals. We assume that NSB introduces larger fluctuation but does
+//  not change the mean value.
+//  To be precise we add quadratically to the rms, which is already in
+//  MPedestalCam, the NSB contribution.
+//  The number of photons from the diffuse NSB follows a poisson
+//  distribution with expected mean value X, then its standard deviation
+//  is sqrt(X).
+//  X is the number of phe per ns so we have to convert in FADC counts per
+//  slice:
+//
+//  Y = sqrt(X * FADC_time / Number_of_slices * pixel_size)
+//      * Amp_single_phe_response
+//
+//  Input Containers:
+//   MMcFadcHeader
+//   MRawRunHeader
+//   [MMcRunHeader]
+//
+//  Output Containers:
+//   MPedestalCam
+//
 /////////////////////////////////////////////////////////////////////////////
 #include "MMcPedestalNSBAdd.h"
@@ -186,9 +186,9 @@
     // is correct.
     //
-    MPedestalCam *pedcam = (MPedestalCam*)pList->FindCreateObj("MPedestalCam");
+    MPedestalCam *pedcam = (MPedestalCam*)pList->FindCreateObj(AddSerialNumber("MPedestalCam"));
     if (!pedcam)
 	return kFALSE;
 
-    MMcFadcHeader *fadc = (MMcFadcHeader*)pList->FindObject("MMcFadcHeader");
+    MMcFadcHeader *fadc = (MMcFadcHeader*)pList->FindObject(AddSerialNumber("MMcFadcHeader"));
     if (!fadc)
     {
@@ -197,5 +197,5 @@
     }
 
-    MGeomCam *geom = (MGeomCam*)pList->FindObject("MGeomCam");
+    MGeomCam *geom = (MGeomCam*)pList->FindObject(AddSerialNumber("MGeomCam"));
     if (!geom)
     {
Index: trunk/MagicSoft/Mars/manalysis/MSigmabarCalc.cc
===================================================================
--- trunk/MagicSoft/Mars/manalysis/MSigmabarCalc.cc	(revision 2454)
+++ trunk/MagicSoft/Mars/manalysis/MSigmabarCalc.cc	(revision 2470)
@@ -25,12 +25,23 @@
 
 /////////////////////////////////////////////////////////////////////////////
-//                                                                         //
-//  MSigmabarCalc                                                          //
-//                                                                         //
-//  This task calculates Sigmabar using the MSigmabar container and stores //
-//  its extremal values together with the corresponding Theta values       //
-//  in MSigmabarParam. For the time being, Theta is taken from a Monte     //
-//  Carlo container. This is preliminary and to be changed ASAP.           //
-//                                                                         //
+//
+//  MSigmabarCalc
+//
+//  This task calculates Sigmabar using the MSigmabar container and stores
+//  its extremal values together with the corresponding Theta values       
+//  in MSigmabarParam. For the time being, Theta is taken from a Monte
+//  Carlo container. This is preliminary and to be changed ASAP.
+//
+//  Input Containers:
+//   MGeomCam
+//   MPedestalCam
+//   MRawRunHeader
+//   MMcEvt  (FIXME: Must be replaced by a 'real-data' container)
+//   MCerPhotEvt
+//
+//  Output Containers:
+//   MSigmabar
+//   MSigmabarParam
+//
 /////////////////////////////////////////////////////////////////////////////
 #include "MSigmabarCalc.h"
@@ -72,5 +83,5 @@
 Int_t MSigmabarCalc::PreProcess(MParList *pList)
 {
-    fCam = (MGeomCam*)pList->FindObject("MGeomCam");
+    fCam = (MGeomCam*)pList->FindObject(AddSerialNumber("MGeomCam"));
     if (!fCam)
     {
@@ -79,5 +90,5 @@
     }
 
-    fPed = (MPedestalCam*)pList->FindObject("MPedestalCam");
+    fPed = (MPedestalCam*)pList->FindObject(AddSerialNumber("MPedestalCam"));
     if (!fPed)
     {
@@ -94,5 +105,5 @@
 
     // This is needed for determining min/max Theta
-    fMcEvt = (MMcEvt*)pList->FindObject("MMcEvt");
+    fMcEvt = (MMcEvt*)pList->FindObject(AddSerialNumber("MMcEvt"));
     if (!fMcEvt)
     {
@@ -102,5 +113,5 @@
     }
 
-    fEvt = (MCerPhotEvt*)pList->FindObject("MCerPhotEvt");
+    fEvt = (MCerPhotEvt*)pList->FindObject(AddSerialNumber("MCerPhotEvt"));
     if (!fEvt)
       {
@@ -109,9 +120,11 @@
       }
 
-    fSig = (MSigmabar*)pList->FindCreateObj("MSigmabar");
+    fSig = (MSigmabar*)pList->FindCreateObj(AddSerialNumber("MSigmabar"));
     if (!fSig)
         return kFALSE;
 
-    fSigParam = (MSigmabarParam*)pList->FindCreateObj("MSigmabarParam");
+    // FIXME: This might have to change in a
+    //        'more-than-one-telescope-environment'
+    fSigParam = (MSigmabarParam*)pList->FindCreateObj(AddSerialNumber("MSigmabarParam"));
     if (!fSigParam)
         return kFALSE;