Index: trunk/MagicSoft/Mars/mhist/MHEvent.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEvent.cc	(revision 2481)
+++ trunk/MagicSoft/Mars/mhist/MHEvent.cc	(revision 2482)
@@ -1,2 +1,47 @@
+/* ======================================================================== *\
+!
+! *
+! * This file is part of MARS, the MAGIC Analysis and Reconstruction
+! * Software. It is distributed to you in the hope that it can be a useful
+! * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
+! * It is distributed WITHOUT ANY WARRANTY.
+! *
+! * Permission to use, copy, modify and distribute this software and its
+! * documentation for any purpose is hereby granted without fee,
+! * provided that the above copyright notice appear in all copies and
+! * that both that copyright notice and this permission notice appear
+! * in supporting documentation. It is provided "as is" without express
+! * or implied warranty.
+! *
+!
+!
+!   Author(s): Thomas Bretz, 11/2003 <mailto:tbretz@astro.uni-wuerzburg.de>
+!
+!   Copyright: MAGIC Software Development, 2000-2003
+!
+!
+\* ======================================================================== */
+
+//////////////////////////////////////////////////////////////////////////////
+//                                                                          
+//  MHEvent
+//                                                                          
+//  Display a single event in a canvas with as many informations as
+//  possible, such as event number, run number, ...
+//
+//  WARNING: This class is not yet ready!
+//
+//  Input Containers:
+//   MGeomCam
+//   [MTaskList]
+//   [MImgCleanStd]
+//   [MRawEvtData]
+//   [MRawRunHeader]
+//   [MRawEvtHeader]
+//
+//  Output Containers:
+//   -/-
+//
+//////////////////////////////////////////////////////////////////////////////
 #include "MHEvent.h"
 
@@ -18,9 +63,28 @@
 #include "MRawEvtHeader.h"
 #include "MRawRunHeader.h"
-
+#include "MRawEvtData.h"
+
+ClassImp(MHEvent);
+
+using namespace std;
+
+// --------------------------------------------------------------------------
+//
+MHEvent::MHEvent(EventType_t type) : fHist(NULL), fType(type)
+{
+    fName = "MHEvent";
+    fTitle = "Single Event display task";
+
+    fClone = new MRawEvtData("MHEventData");
+}
+
+// --------------------------------------------------------------------------
+//
 MHEvent::~MHEvent()
 {
     if (fHist)
         delete fHist;
+
+    delete fClone;
 }
 
@@ -29,5 +93,5 @@
     MTaskList *tlist = (MTaskList*)plist->FindObject("MTaskList");
 
-    fImgCleanStd = (MImgCleanStd*)tlist->FindObject("MImgCleanStd");
+    fImgCleanStd = tlist ? (MImgCleanStd*)tlist->FindObject("MImgCleanStd") : NULL;
     fMcEvt       = (MMcEvt*)plist->FindObject("MMcEvt");
 
@@ -55,5 +119,5 @@
 
     fHist = new MHCamera(*cam);
-    fHist->AddNotify(fClone);
+    fHist->AddNotify(*fClone);
 
     switch (fType)
@@ -86,5 +150,5 @@
 }
 
-Bool_t MHEvent::Fill(const MParContainer *par, const Stat_t weight=1)
+Bool_t MHEvent::Fill(const MParContainer *par, const Stat_t weight)
 {
     if (fHist->IsFreezed())
@@ -95,5 +159,5 @@
 
     if (fRawEvtData)
-        fRawEvtData->Copy(fClone);
+        fRawEvtData->Copy(*fClone);
 
     switch (fType)
Index: trunk/MagicSoft/Mars/mhist/MHEvent.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEvent.h	(revision 2481)
+++ trunk/MagicSoft/Mars/mhist/MHEvent.h	(revision 2482)
@@ -4,8 +4,4 @@
 #ifndef MARS_MH
 #include "MH.h"
-#endif
-
-#ifndef MARS_MRawEvtData
-#include "MRawEvtData.h"
 #endif
 
@@ -28,4 +24,5 @@
         kEvtRelativeSignal, kEvtCleaningLevels
     };
+
 private:
     MRawEvtData   *fRawEvtData;    //!
@@ -38,5 +35,5 @@
     MImgCleanStd  *fImgCleanStd;   //!
 
-    MRawEvtData    fClone;         //!
+    MRawEvtData   *fClone;         //->
 
     MHCamera *fHist;
@@ -50,12 +47,9 @@
 
 public:
-    MHEvent(EventType_t type=kEvtSignal) : fClone("MHEventData"), fHist(NULL), fType(type)
-    {
-    }
+    MHEvent(EventType_t type=kEvtSignal);
     ~MHEvent();
 
     MHCamera *GetHist() { return fHist; }
 
-    //void DrawTS(TVirtualPad *pad=NULL, Option_t *o="");
     void Draw(Option_t *o="");
  